#!/usr/bin/env python3
from time import sleep
import sys
import re

def gui(InString, OutputFile, RepeatString):
	OutputFile.write(RepeatString + "\tKeyboard.press(KEY_LEFT_GUI);\n")
	if(InString > ""):
		OutputFile.write(RepeatString + "\tKeyboard.press('"+ InString +"');\n")
	OutputFile.write(RepeatString + "\tdelay(100);\n")
	OutputFile.write(RepeatString + "\tKeyboard.releaseAll();\n")
	return 1

def menu(OutputFile, RepeatString):
	OutputFile.write(RepeatString + "\tKeyboard.press(KEY_LEFT_SHIFT);\n")
	OutputFile.write(RepeatString + "\tKeyboard.press(KEY_F10);\n")
	OutputFile.write(RepeatString + "\tdelay(100);\n")
	OutputFile.write(RepeatString + "\tKeyboard.releaseAll();\n\n")
	return 1

def shift(InString, OutputFile, RepeatString):
	result = 0
	if(InString == "DELETE"):
		OutString = "KEY_DELETE"
		result = 1
	if(InString == "HOME"):
		OutString = "KEY_HOME"
		result = 1
	if(InString == "INSERT"):
		OutString = "KEY_INSERT"
		result = 1
	if(InString == "PAGEUP"):
		OutString = "KEY_PAGE_UP"
		result = 1
	if(InString == "PAGEDOWN"):
		OutString = "KEY_PAGE_DOWN"
		result = 1
	if(InString == "WINDOWS" or InString == "GUI"):
		OutString = "KEY_LEFT_GUI"
		result = 1
	if(InString == "UPARROW"  or InString == "UP"):
		OutString = "KEY_UP_ARROW"
		result = 1
	if(InString == "DOWNARROW" or InString == "DOWN"):
		OutString = "KEY_DOWN_ARROW"		
		result = 1
	if(InString == "LEFTARROW" or InString == "LEFT"):
		OutString = "KEY_LEFT_ARROW"
		result = 1
	if(InString == "RIGHTARROW" or InString == "RIGHT"):
		OutString = "KEY_RIGHT_ARROW"
		result = 1
	if(InString == "TAB" ):
		OutString = "KEY_TAB"
		result = 1
	if(result):
		OutputFile.write(RepeatString + "\tKeyboard.press(KEY_LEFT_SHIFT);\n")
		OutputFile.write(RepeatString + "\tKeyboard.press("+ OutString +");\n")
		OutputFile.write(RepeatString + "\tdelay(100);\n")
		OutputFile.write(RepeatString + "\tKeyboard.releaseAll();\n\n")
	return result

def alt(InString, OutputFile, RepeatString):
	result = 0
	if (InString == "END"):
		OutString = "KEY_END"
		result = 1		
	if (InString == "ESC" or InString == "ESCAPE"):
		OutString = "KEY_END"
		result = 1
	if (InString == "ESC" or InString == "ESCAPE"):
		OutString = "KEY_ESC"
		result = 1
	if (len(InString) > 1 and  InString.startswith('F')):
		OutString = "KEY_F" + InString[1:]
		result = 1
	if (len(InString) == 1):
		OutString = "'" + InString + "'"
		result = 1
	if (InString == "SPACE"):
		OutString = "' '"
		result = 1
	if(InString == "TAB"):
		OutString = "KEY_TAB"
		result = 1
	if(result):
		OutputFile.write(RepeatString + "\tKeyboard.press(KEY_LEFT_ALT);\n")
		OutputFile.write(RepeatString + "\tKeyboard.press("+ OutString +");\n")
		OutputFile.write(RepeatString + "\tdelay(100);\n")
		OutputFile.write(RepeatString + "\tKeyboard.releaseAll();\n\n")
	return result


def ctrl(InString, OutputFile, RepeatString):
	result = 0
	if (InString == "ESC" or InString == "ESCAPE"):
		OutString = "KEY_ESC"
		result = 1
	if (len(InString) > 1 and  InString.startswith('F')):
		OutString = "KEY_F" + InString[1:]
		result = 1
	if (len(InString) == 1):
		OutString = "'" + InString + "'"
		result = 1
	if(result):
		OutputFile.write(RepeatString + "\tKeyboard.press(KEY_LEFT_CTRL);\n")
		OutputFile.write(RepeatString + "\tKeyboard.press("+ OutString +");\n")
		OutputFile.write(RepeatString + "\tdelay(100);\n")
		OutputFile.write(RepeatString + "\tKeyboard.releaseAll();\n\n")
	return result

def arrow(InString, OutputFile, RepeatString):
	result = 0
	if(InString == "DOWNARROW" or InString == "DOWN"):
		OutString = "KEY_DOWN_ARROW"
		result = 1
	if(InString == "LEFTARROW" or InString == "LEFT"):
		OutString = "KEY_LEFT_ARROW"
		result = 1
	if(InString == "RIGHTARROW" or InString == "RIGHT"):
		OutString = "KEY_RIGHT_ARROW"
		result = 1
	if(InString == "UPARROW" or InString == "UP"):
		OutString = "KEY_UP_ARROW"
		result = 1
	if(result):
		OutputFile.write(RepeatString + "\tKeyboard.press("+ OutString +");\n")
		OutputFile.write(RepeatString + "\tdelay(100);\n")
		OutputFile.write(RepeatString + "\tKeyboard.releaseAll();\n\n")
	return result

def extendedCommands(InString, OutputFile, RepeatString):
	result = 0
	if(InString == "CAPSLOCK"):
		OutString = "KEY_CAPS_LOCK"
		result = 1		
	if(InString == "DELETE"):
		OutString = "KEY_DELETE"
		result = 1
	if(InString == "END"):
		OutString = "KEY_END"
		result = 1
	if(InString == "ESC" or InString == "ESCAPE"):
		OutString = "KEY_ESC"
		result = 1
	if(InString == "HOME"):
		OutString = "KEY_HOME"
		result = 1
	if(InString == "INSERT"):
		OutString = "KEY_INSERT"
		result = 1
	if(InString == "PAGEUP"):
		OutString = "KEY_PAGE_UP"
		result = 1
	if(InString == "PAGEDOWN"):
		OutString = "KEY_PAGE_DOWN"
		result = 1
	if(InString == "SPACE"):
		OutString = "' '"
		result = 1
	if(InString == "TAB"):
		OutString = "KEY_TAB"
		result = 1
	if(result):
		OutputFile.write(RepeatString + "\tKeyboard.press("+ OutString +");\n")
		OutputFile.write(RepeatString + "\tdelay(100);\n")
		OutputFile.write(RepeatString + "\tKeyboard.releaseAll();\n\n")
	return result

def string(InString, OutputFile, RepeatString):
	InString = InString.split(" ")

	for string in InString:
		if(re.search("~[|{}@\[\]\\\\]", string)):
			string = re.sub('[|{}@\[\]\\\\]', ' \g<0> ', string)
			string = string.split(" ")

			for substring in string:
				if(substring == '|' or substring == '\\' or substring == '[' or substring == ']' or substring == '~' or substring == '{' or substring == '}' or substring == '}' or substring == '@'):
					if(substring == '\\'):
						OutString = "\\\\"
					if(substring == '['):
						OutString = "["
					if(substring == ']'):
						OutString = "]"
					if(substring == '{'):
						OutString = "{"
					if(substring == '}'):
						OutString = "}"
					if(substring == '|'):
						OutString = "|"
					if(substring == '@'):
						OutString = "@"
					if(substring == '~'):
						OutString = "~"

					OutputFile.write(RepeatString + "\tKeyboard.press(KEY_RIGHT_ALT);\n")
					OutputFile.write(RepeatString + "\tKeyboard.press('"+ OutString +"');\n")
					OutputFile.write(RepeatString + "\tdelay(100);\n")
					OutputFile.write(RepeatString + "\tKeyboard.releaseAll();\n")
				elif (substring == ''):
						continue
				else:
					OutputFile.write(RepeatString + '\tKeyboard.print("' + substring + '");\n')
		else:
			OutputFile.write(RepeatString + '\tKeyboard.print("' + string + '");\n')
		OutputFile.write(RepeatString + '\tKeyboard.print("\\n");\n')
	return 1


def main():

	print("DukyScriptToArduinoHID.py ver 1.0.0")

	if(len(sys.argv) < 3):
		print("Usage:")
		print("	DukyScriptToArduinoHID.py [DuckyScriptFile] [OutputFile]")
	else:

		linecount = 0
		with open(sys.argv[1], 'r') as f:
			for line in f:
				linecount += 1
			print("Total number of lines to process:" + str(linecount))

		InputFile = open(sys.argv[1], "r")
		

		try:
			OutputFile = open(sys.argv[2], "x")
		except:
			OutputFile = open(sys.argv[2], "w")

		OutputFile.write("#include <Keyboard.h>\n")
		OutputFile.write("void setup() {\n")
		OutputFile.write("\tdelay(1000); \n")
		OutputFile.write("\tKeyboard.begin(); \n")
		OutputFile.write("\tdelay(500); \n")


		Readbuffer = ["String1","String2"]
		ErrorList = ["Error list:"]

		Readbuffer[0] = InputFile.readline()
		Readbuffer[1] = InputFile.readline()

		for count in range (linecount):	
			result = 0;

			if(Readbuffer[1].startswith("REPEAT")):
				if((count + 1) == linecount and Readbuffer[0] > '\n'):
					String = Readbuffer[1]
				else:
					String = Readbuffer[1][:-1]
				String = String.split(" ")

				OutputFile.write("\tfor (int i = 0; i < "+ String[1] + "; i++){\n")
				RepeatString = '\t'

			else:
				RepeatString = ''
			
			if((count + 1) == linecount and Readbuffer[0] > '\n'):
				String = Readbuffer[0]
			else:
				String = Readbuffer[0][:-1]

			String = String.split(" ")

			if(String[0] == ""):
				OutputFile.write("\n")
				result = 1

			if(String[0] == "REM"):
				OutputFile.write(RepeatString + "\t//" + Readbuffer[0][3:])
				result = 1

			if(String[0] == "DEFAULT_DELAY" or String[0] == "DEFAULTDELAY"):
				ErrorList.append("Line:" + str(count + 1) + "\t\t Keyboard.h does not use the " + String[0] + " Command but it already runs sequentially.")
				result = 1

			if(String[0] == "WINDOWS" or String[0] == "GUI"):
				result = gui(String[1], OutputFile, RepeatString) 

			if(String[0] == "MENU" or String[0] == "APP"):
				result = menu(OutputFile, RepeatString)

			if(String[0] == "DELAY" and String[1] > ""):
				OutputFile.write(RepeatString + "\tdelay(" + String[1] + ");\n")
				result = 1

			if(String[0] == "STRING" and String[1] > ""):
				result = string(String[1], OutputFile, RepeatString) 

			if(String[0] == "SHIFT" and String[1] > ""):
				result = shift(String[1], OutputFile, RepeatString) 

			if(String[0] == "ALT" and String[1] > ""):
				result = alt(String[1], OutputFile, RepeatString)

			if(String[0] == "CONTROL" and String[1] > "" or String[0] == "CTRL" and String[1] > "" ): 	
				result = ctrl(String[1], OutputFile, RepeatString)

			if(String[0] == "DOWNARROW" or String[0] == "DOWN" or String[0] == "LEFTARROW" or String[0] == "LEFT" or String[0] == "RIGHTARROW" or String[0] == "RIGHT" or String[0] == "UPARROW" or String[0] == "UP"):
				result = arrow(String[0], OutputFile, RepeatString)

			if(String[0] == "CAPSLOCK" or String[0] == "DELETE" or String[0] == "END" or String[0] == "ESC" or String[0] == "ESCAPE" or String[0] == "HOME" or String[0] == "INSERT" or String[0] == "PAGEUP" or String[0] == "PAGEDOWN" or String[0] == "SPACE" or String[0] == "TAB"):
				result = extendedCommands(String[0], OutputFile, RepeatString)

			if(String[0] == "BREAK" or String[0] == "PAUSE" or String[0] == "NUMLOCK" or String[0] == "PRINTSCREEN" or String[0] == "SCROLLLOCK"):
				ErrorList.append("Line:" + str(count + 1) + "\t\t Keyboard.h does not implement the " + String[0] + " Key.")
				result = 1

			if(result == 0):
				ErrorList.append("Line:" + str(count + 1) + '\t\t Some error occurred with the "' +  Readbuffer[0][:-1] + '" command.')

			if(Readbuffer[1].startswith("REPEAT")):
				OutputFile.write("\t}")
				Readbuffer[0] = InputFile.readline()
				Readbuffer[1] = InputFile.readline()
			else:
				Readbuffer[0] = Readbuffer[1]
				Readbuffer[1] = InputFile.readline()


		OutputFile.write("\tKeyboard.end();")
		OutputFile.write("\n}\n\nvoid loop() {}\n")

		InputFile.close()
		OutputFile.close()


		if(len(ErrorList) > 1):
			print('\n')
			for line in ErrorList:
				print(line)

if __name__ == "__main__":
    main()